## busybox 1.20.0

=== Makefile ===
VERSION = 1
PATCHLEVEL = 20
SUBLEVEL = 0
EXTRAVERSION =
NAME = Unnamed

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into busybox), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH TOPDIR


# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

CROSS_COMPILE ?=
# bbox: we may have CONFIG_CROSS_COMPILER_PREFIX in .config,
# and it has not been included yet... thus using an awkward syntax.
ifeq ($(CROSS_COMPILE),)
CROSS_COMPILE := $(shell grep ^CONFIG_CROSS_COMPILER_PREFIX .config 2>/dev/null)
CROSS_COMPILE := $(subst CONFIG_CROSS_COMPILER_PREFIX=,,$(CROSS_COMPILE))
CROSS_COMPILE := $(subst ",,$(CROSS_COMPILE))
#")
endif

# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

ifneq ($(CROSS_COMPILE),)
SUBARCH := $(shell echo $(CROSS_COMPILE) | cut -d- -f1)
else
SUBARCH := $(shell uname -m)
endif
SUBARCH := $(shell echo $(SUBARCH) | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
					 -e s/arm.*/arm/ -e s/sa110/arm/ \
					 -e s/s390x/s390/ -e s/parisc64/parisc/ \
					 -e s/ppc.*/powerpc/ -e s/mips.*/mips/ )

ARCH ?= $(SUBARCH)

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

# 	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

HOSTCC  	= gcc
HOSTCXX  	= g++
HOSTCFLAGS	:=
HOSTCXXFLAGS	:=
# We need some generic definitions
include $(srctree)/scripts/Kbuild.include

HOSTCFLAGS	+= $(call hostcc-option,-Wall -Wstrict-prototypes -O2 -fomit-frame-pointer,)
HOSTCXXFLAGS	+= -O2

# For maximum performance (+ possibly random breakage, uncomment
# the following)

MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
CC		= $(CROSS_COMPILE)gcc
LD		= $(CC) -nostdlib
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ -Wbitwise $(CF)
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
CFLAGS		:= $(CFLAGS)
# Added only to final link stage of busybox binary
CFLAGS_busybox	:= $(CFLAGS_busybox)
CPPFLAGS	:= $(CPPFLAGS)
AFLAGS		:= $(AFLAGS)
LDFLAGS		:= $(LDFLAGS)
LDLIBS		:=

# Read KERNELRELEASE from .kernelrelease (if it exists)
KERNELRELEASE = $(shell cat .kernelrelease 2> /dev/null)
KERNELVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

export	VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE
export FLTFLAGS

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS -o -name .pc -o -name .hg -o -name .git \) -prune -o
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

# This target generates Kbuild's and Config.in's from *.c files
PHONY += gen_build_files
gen_build_files: $(wildcard $(srctree)/*/*.c) $(wildcard $(srctree)/*/*/*.c)
	$(Q)$(srctree)/scripts/gen_build_files.sh $(srctree) $(objtree)

# bbox: we have helpers in applets/
# we depend on scripts_basic, since scripts/basic/fixdep
# must be built before any other host prog
PHONY += applets_dir
applets_dir: scripts_basic gen_build_files
	$(Q)$(MAKE) $(build)=applets

applets/%: applets_dir ;

PHONY += outputmakefile
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
outputmakefile:
ifneq ($(KBUILD_SRC),)

=== debian/changelog ===
busybox (1:1.20.0-8ubuntu1) raring; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Set V=1 in debian/rules, to get more meaningful build logs.
    - Enable 'mount -f' and mount helpers for all targets.
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - glibc-2.16-ftbfs.patch: fix missing include with glibc 2.16.
    + Refresh busybox-initramfs config to keep it in sync with the featureset
      of the other builds:
      - copybuf size bumped to 64kb
      - enable xargs features.
      - enable CONFIG_FEATURE_PS_LONG.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 13 Mar 2013 15:52:08 +0000

busybox (1:1.20.0-7ubuntu3) raring; urgency=low

  [ Timo Juhani Lindfors ]
  * increase the maximum supported log line length from 256 to 512
    bytes. (Closes: #519356, LP: #1040900)

 -- Adam Stokes <adam.stokes@canonical.com>  Mon, 05 Nov 2012 12:57:13 -0500

busybox (1:1.20.0-7ubuntu2) raring; urgency=low

  * debian/patches/glibc-2.16-ftbfs.patch: fix missing include with
    glibc 2.16.
  * Re-enable NFS support in the static build, as this incompatibility seems
    to have gone away with the combination of 1.20.0 and glibc 2.16.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 29 Oct 2012 00:47:06 +0100

busybox (1:1.20.0-7ubuntu1) raring; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Set V=1 in debian/rules, to get more meaningful build logs.
    - Enable 'mount -f' and mount helpers for all targets.
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - Disable NFS mount in the static build.
  * Dropped changes, included in Debian:
    - Export the dpkg-buildflags to the environment, so we pick up hardening
      now that dpkg doesn't export them for us.
    - Filter out -Werror=format-security from CFLAGS passed by
      dpkg-buildpackage.
    - [deb, static] Enable CGI support for httpd.
    - [udeb] Enable NFS mount, ping and ping6
  * Dropped changes:
    - debian/patches/fix-64-bit-permissions.patch: mkdir: fix permissions
      on 64-bit platforms; included upstream.
  * Refresh busybox-initramfs config to keep it in sync with the featureset
    of the other builds:
    - copybuf size bumped to 64kb
    - enable xargs features.
    - enable CONFIG_FEATURE_PS_LONG.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 25 Oct 2012 01:31:59 +0000

busybox (1:1.19.3-7ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
    - [udeb] Enable chvt, killall, losetup, NFS mount, od, ping, ping6, and
      stat.
    - [deb, static] Enable CGI support for httpd.
    - Enable 'mount -f' and mount helpers for all targets.
    - Add busybox-initramfs.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - debian/patches/fix-64-bit-permissions.patch: mkdir: fix permissions
      on 64-bit platforms.  Taken from upstream.
    - Filter out -Werror=format-security from CFLAGS passed by
      dpkg-buildpackage, at least for now.
  * Dropped changes, included in Debian:
    - [deb] Enable mdev.
    - Add cross-compiling support.
  * Disable NFS mount in the static build; needs a newer upstream version of
    busybox for compatibility with glibc 2.15.
  * Set V=1 in debian/rules, to get more meaningful build logs.
  * Export the dpkg-buildflags to the environment, so we pick up hardening
    now that dpkg doesn't export them for us.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 01 May 2012 03:35:20 +0000

## busybox 1.21.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 VERSION = 1
-PATCHLEVEL = 20
+PATCHLEVEL = 21
 SUBLEVEL = 0
 EXTRAVERSION =
 NAME = Unnamed
@@ -297,6 +297,7 @@
 STRIP		= $(CROSS_COMPILE)strip
 OBJCOPY		= $(CROSS_COMPILE)objcopy
 OBJDUMP		= $(CROSS_COMPILE)objdump
+PKG_CONFIG	?= $(CROSS_COMPILE)pkg-config
 AWK		= awk
 GENKSYMS	= scripts/genksyms/genksyms
 DEPMOD		= /sbin/depmod
@@ -377,4 +378,3 @@
 # separate output directory. This allows convenient use of make in the
 # output directory.
 outputmakefile:
-ifneq ($(KBUILD_SRC),)

=== debian/control ===
Source: busybox
Priority: optional
Section: utils
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.4
Vcs-Git: git://anonscm.debian.org/d-i/busybox.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=d-i/busybox.git
Homepage: http://www.busybox.net

Package: busybox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: busybox-static
Replaces: busybox-static
Description: Tiny utilities for small and embedded systems
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 This package installs the BusyBox binary but does not install
 symlinks for any of the supported utilities. Some of the utilities
 can be used in the system by installing the busybox-syslogd,
 busybox-udhcpc or busybox-udhcpd packages.

Package: busybox-static
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: busybox
Replaces: busybox
Priority: extra
Section: shells
Description: Standalone rescue shell with tons of builtin utilities
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.).  The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-static provides you with a statically linked simple stand alone shell
 that provides all the utilities available in BusyBox. This package is
 intended to be used as a rescue shell, in the event that you screw up your
 system. Invoke "busybox sh" and you have a standalone shell ready to save
 your system from certain destruction. Invoke "busybox", and it will list the
 available builtin commands.

Package: busybox-initramfs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: busybox-cvs-initramfs
Replaces: busybox-cvs-initramfs
Section: shells
Description: Standalone shell setup for initramfs
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-initramfs provides a simple stand alone shell that provides
 only the basic utilities needed for the initramfs.

Package: busybox-udeb
Package-Type: udeb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Priority: extra
Description: Tiny utilities for the debian-installer
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-udeb is used by the debian-installer, so unless you are working on
 the debian-installer, this package is not for you. Installing this 
 on your Debian system is a very, very bad idea. You have been warned.

Package: busybox-syslogd
Architecture: all
Depends: busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}), ${misc:Depends}
Provides: linux-kernel-log-daemon, system-log-daemon, klogd, syslogd
Replaces: sysklogd, klogd, inetutils-syslogd
Conflicts: klogd, syslogd, sysklogd, linux-kernel-log-daemon, system-log-daemon
Description: Provides syslogd and klogd using busybox
 The system log daemon is responsible for providing logging of
 messages received from programs and facilities on the local host as
 well as from remote hosts.
 .
 The kernel log daemon listens to kernel message sources and is
 responsible for prioritizing and processing operating system
 messages.
 .
 The busybox implementation of the syslogd is particular useful on
 embedded, diskless (netboot) or flash disk based systems because it
 can use a fixed size ring buffer for logging instead of saving logs
 to the disk or sending it to remote logging servers. The ring buffer
 can be read using the (also busybox based) command logread.
 .
 This package provides the glue to the busybox syslogd and klogd to be
 used in the system by providing the appropriate symbolic links and
 scripts.

Package: udhcpc
Section: net
Architecture: linux-any
Depends: busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}), ${misc:Depends}
Description: Provides the busybox DHCP client implementation
 Busybox contains a very small yet fully function RFC compliant DHCP
 client formerly known as udhcpc.
 .
 This package contains the glue to use the busybox udhcpc as DHCP
 client in the system by providing the appropriate symbolic links and
 scripts.

Package: udhcpd
Section: net
Architecture: linux-any
Depends: busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}), ${misc:Depends}
Provides: dhcpd
Description: Provides the busybox DHCP server implementation
 Busybox contains a very small yet fully function RFC compliant DHCP
 server formerly known as udhcpd.
 .
 This package contains the glue to use the busybox udhcpd as DHCP
 server in the system by providing the appropriate symbolic links and
 scripts.

=== debian/rules ===
#!/usr/bin/make -f

SHELL := sh -e
DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
SOURCE := $(shell dpkg-parsechangelog | sed -ne 's,^Source: *\(.*\)$$,\1,p')
VERSION_DEBIAN := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')
VERSION := $(shell echo "$(VERSION_DEBIAN)" | sed -e 's,^[^:]*:,,' -e 's,-[^-]*$$,,')
VENDOR := $(shell dpkg-vendor --query vendor)

BUILD_DIR = debian/build

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
export CROSS_COMPILE = $(DEB_HOST_GNU_TYPE)-
endif

# we filter out -Werror=format-security from CFLAGS, because
# bb uses constructs like
#  bb_error_msg_and_die(bb_msg_memory_exhausted);
# in many places, and for these, gcc with -Werror=format-security
# will complain, since bb_msg_memory_exhausted is an extern.
EXTRA_CFLAGS = \
 $(filter-out -Werror=format-security, $(shell dpkg-buildflags --get CFLAGS))
EXTRA_LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
EXTRA_CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

build: build-arch build-indep
build-indep:

setup: $(BUILD_DIR)/deb/.setup $(BUILD_DIR)/static/.setup $(BUILD_DIR)/udeb/.setup $(BUILD_DIR)/initramfs/.setup

$(BUILD_DIR)/%/.setup: SOURCE_FILES = $(filter-out debian, $(wildcard *))
$(BUILD_DIR)/%/.setup: DIR = $(BUILD_DIR)/$*
$(BUILD_DIR)/%/.setup: debian/config/pkg/% debian/config/os/$(DEB_HOST_ARCH_OS)
	dh_testdir
	rm -rf '$(DIR)'
	mkdir -p '$(DIR)'
	cp -a -l $(SOURCE_FILES) '$(DIR)'

# Generate the .config file. First variable assignment wins.
# Several steps..

# 1, rm it just in case
	rm -f $(DIR)/.config

# 2, put any arch-specific overrides so they will have higher precedence
# should be empty for linux
	cat debian/config/os/$(DEB_HOST_ARCH_OS) > $(DIR)/.config

# 3, on non-linux platform, disable all config symbols
# which select PLATFORM_LINUX.
# Configuration information is stored in source files and in Config.src,
# so we have to generate Config.in files first, -- done by gen_build_files.
	$(MAKE) -C $(DIR) gen_build_files
ifneq (linux,$(DEB_HOST_ARCH_OS))
	find $(DIR) -name Config.in -exec \
	  awk '$$1 == "config" { conf = $$2 } \
	       $$1 == "select" && $$2 == "PLATFORM_LINUX" \
	       { print "CONFIG_" conf "=n"; }' \
	   {} + \
        | sort -u >> $(DIR)/.config
endif

# 4, use the flavour-specific base config file.
	cat debian/config/pkg/$* >> $(DIR)/.config

# 5, sort out the resulting mess using oldconfig Kbuild machinery
	$(MAKE) -C $(DIR) oldconfig

	ln -s .config $@

build-arch: $(BUILD_DIR)/deb/.built $(BUILD_DIR)/static/.built $(BUILD_DIR)/udeb/.built $(BUILD_DIR)/initramfs/.built

$(BUILD_DIR)/%/.built: DIR = $(BUILD_DIR)/$*
$(BUILD_DIR)/%/.built: $(BUILD_DIR)/%/.setup
	dh_testdir
	$(MAKE) -C '$(DIR)' V=1 install docs/busybox.1 \
	  SKIP_STRIP=y \
	  BB_EXTRA_VERSION="$(VENDOR) $(VERSION_DEBIAN)" \
	  CONFIG_EXTRA_CFLAGS='$(EXTRA_CFLAGS) $(EXTRA_CPPFLAGS)' \
	  CONFIG_EXTRA_LDFLAGS='$(EXTRA_LDFLAGS)'
	touch $@

clean:
	dh_testdir
	rm -rf $(BUILD_DIR)
	dh_clean

binary-indep: binary-indep_busybox-syslogd

binary-arch: binary-arch_busybox binary-arch_busybox-static binary-arch_busybox-udeb binary-arch_busybox-initramfs
ifeq (linux,$(DEB_HOST_ARCH_OS))
binary-arch: binary-arch_udhcpc binary-arch_udhcpd
endif

binary-arch_busybox: DIR = $(BUILD_DIR)/deb
binary-arch_busybox: export DH_OPTIONS = -pbusybox
binary-arch_busybox: $(BUILD_DIR)/deb/.built
	dh_testdir
	dh_testroot
	dh_prep
	dh_install --sourcedir=$(DIR)
	dh_installdocs docs/syslog.conf.txt docs/mdev.txt
	dh_installexamples examples/mdev* examples/udhcp
	@$(MAKE) -f debian/rules binary-arch_all

binary-arch_busybox-static: DIR = $(BUILD_DIR)/static
binary-arch_busybox-static: export DH_OPTIONS = -pbusybox-static
binary-arch_busybox-static: $(BUILD_DIR)/static/.built
	dh_testdir
	dh_testroot
	dh_prep
	dh_install --sourcedir=$(DIR)
	dh_installdocs docs/syslog.conf.txt docs/mdev.txt
	dh_installexamples examples/mdev* examples/udhcp
	@$(MAKE) -f debian/rules binary-arch_all

binary-arch_busybox-udeb: DIR = $(BUILD_DIR)/udeb
binary-arch_busybox-udeb: export DH_OPTIONS = -pbusybox-udeb
binary-arch_busybox-udeb: $(BUILD_DIR)/udeb/.built
	dh_testdir
	dh_testroot
	dh_prep
	# Remove init link, but init support is still compiled in to be
	# used.
	rm -f $(DIR)/_install/sbin/init
	dh_install --sourcedir=$(DIR)
	@$(MAKE) -f debian/rules binary-arch_all

binary-arch_busybox-initramfs: DIR = $(BUILD_DIR)/initramfs
binary-arch_busybox-initramfs: export DH_OPTIONS = -pbusybox-initramfs
binary-arch_busybox-initramfs: $(BUILD_DIR)/initramfs/.built
	dh_testdir
	dh_testroot
	dh_prep
	dh_install --sourcedir=$(DIR)
	@$(MAKE) -f debian/rules binary-arch_all

binary-arch_all:
	dh_installdirs
	dh_installdocs
	dh_installchangelogs
	dh_strip
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep_busybox-syslogd: export DH_OPTIONS = -pbusybox-syslogd
binary-indep_busybox-syslogd:
	dh_testdir
	dh_testroot
	dh_prep
	dh_link
	dh_installinit -u"defaults 10 90"
	dh_installinit -u"defaults 11 89" --name=busybox-klogd
	$(MAKE) -f debian/rules binary-indep_all

binary-arch_udhcpc: export DH_OPTIONS = -pudhcpc
binary-arch_udhcpc:
	dh_testdir
	dh_testroot
	dh_prep
	dh_link
	dh_install
	$(MAKE) -f debian/rules binary-indep_all

binary-arch_udhcpd: export DH_OPTIONS = -pudhcpd
binary-arch_udhcpd:
	dh_testdir
	dh_testroot
	dh_prep
	dh_link
	dh_installinit --onlyscripts
	dh_install
	$(MAKE) -f debian/rules binary-indep_all

binary-indep_all:
	dh_installdirs
	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

## busybox 1.22.0

=== debian/changelog ===
busybox (1:1.22.0-15ubuntu1) wily; urgency=low

  * Merge from Debian unstable (LP: #1486231).  Remaining changes:
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - Refresh busybox-initramfs config to keep it in sync with the featureset
      of the other builds.  (No changes upstream.)
    - Enable chpasswd in standard and static builds (needed by LXC).
    - Move zz-busybox to busybox-initramfs to ensure we get links to all
      the tools we need, stop shipping it anywhere else.
    - Prefer busybox commands over klibc commands where there is duplication.

 -- Andy Whitcroft <apw@ubuntu.com>  Wed, 19 Aug 2015 11:30:32 +0100

busybox (1:1.22.0-9ubuntu2) wily; urgency=medium

  * Move zz-busybox to busybox-initramfs to ensure we get links to all
    the tools we need, stop shipping it anywhere else.  (LP: #1481733)
  * Prefer busybox commands over klibc commands where there is duplication.

 -- Andy Whitcroft <apw@ubuntu.com>  Fri, 07 Aug 2015 13:03:51 +0100

busybox (1:1.22.0-9ubuntu1) vivid; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - Refresh busybox-initramfs config to keep it in sync with the featureset
      of the other builds.
    - Enable chpasswd in standard and static builds (needed by LXC).

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 27 Oct 2014 09:33:47 +0100

busybox (1:1.22.0-8ubuntu1) utopic; urgency=low

  * Merge from Debian unstable (LP: #1352413).  Remaining changes:
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - Refresh busybox-initramfs config to keep it in sync with the featureset
      of the other builds.
    - Enable chpasswd in standard and static builds (needed by LXC).

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 04 Aug 2014 17:16:48 +0200

busybox (1:1.22.0-6ubuntu1) utopic; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - Refresh busybox-initramfs config to keep it in sync with the featureset
      of the other builds.
    - Enable chpasswd in standard and static builds (needed by LXC).

 -- Stéphane Graber <stgraber@ubuntu.com>  Fri, 02 May 2014 16:51:04 -0400

busybox (1:1.22.0-5ubuntu1) utopic; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - Refresh busybox-initramfs config to keep it in sync with the featureset
      of the other builds.
    - Enable chpasswd in standard and static builds (needed by LXC).

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 01 May 2014 16:54:03 -0400

busybox (1:1.21.0-1ubuntu1) trusty; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Set V=1 in debian/rules, to get more meaningful build logs.
    - Enable 'mount -f' and mount helpers for all targets.
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    - Refresh busybox-initramfs config to keep it in sync with the featureset
      of the other builds.
    - Enable chpasswd in standard and static builds (needed by LXC).

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 14 Nov 2013 16:15:35 -0500

busybox (1:1.20.0-9ubuntu2) trusty; urgency=low

  * Enable chpasswd in the standard and static builds (needed by LXC).

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 22 Oct 2013 13:00:31 -0400

busybox (1:1.20.0-9ubuntu1) trusty; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Set V=1 in debian/rules, to get more meaningful build logs.
    - Enable 'mount -f' and mount helpers for all targets.
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.
    + Refresh busybox-initramfs config to keep it in sync with the featureset
      of the other builds:
      - copybuf size bumped to 64kb
      - enable xargs features.
      - enable CONFIG_FEATURE_PS_LONG.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Mon, 21 Oct 2013 15:59:06 +0100

busybox (1:1.20.0-8.1ubuntu1) saucy; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Set V=1 in debian/rules, to get more meaningful build logs.
    - Enable 'mount -f' and mount helpers for all targets.
    - [udeb] Enable chvt, killall, losetup, od, and stat.
    - test-bin.patch: Move test and friends to /bin.
    - static-sh-alias.patch: Add static-sh alias name for ash, and install
      /bin/static-sh symlink to busybox in busybox-static.
    - Add busybox-initramfs.


=== debian/control ===
--- 
+++ 
@@ -4,8 +4,13 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
 Uploaders: Bastian Blank <waldi@debian.org>, Michael Tokarev <mjt@tls.msk.ru>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9),
+# needs for testsuite to run
+  zip,
+# glibc static-nss #754813, 2.19..2.19-11, -12 is ok. Depend on libc-dev-bin
+# as it is the package which is named the same on all architectures
+ libc-dev-bin (>> 2.19-12~) | libc-dev-bin (<< 2.19),
+Standards-Version: 3.9.5
 Vcs-Git: git://anonscm.debian.org/d-i/busybox.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=d-i/busybox.git
 Homepage: http://www.busybox.net
@@ -15,6 +20,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: busybox-static
 Replaces: busybox-static
+Breaks: initramfs-tools (<<0.99)
 Description: Tiny utilities for small and embedded systems
  BusyBox combines tiny versions of many common UNIX utilities into a single
  small executable. It provides minimalist replacements for the most common
@@ -31,9 +37,11 @@
 
 Package: busybox-static
 Architecture: any
+Built-Using: ${built-using}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: busybox
 Replaces: busybox
+Provides: busybox
 Priority: extra
 Section: shells
 Description: Standalone rescue shell with tons of builtin utilities
@@ -55,8 +63,6 @@
 Package: busybox-initramfs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: busybox-cvs-initramfs
-Replaces: busybox-cvs-initramfs
 Section: shells
 Description: Standalone shell setup for initramfs
  BusyBox combines tiny versions of many common UNIX utilities into a single
@@ -92,9 +98,8 @@
 Package: busybox-syslogd
 Architecture: all
 Depends: busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}), ${misc:Depends}
-Provides: linux-kernel-log-daemon, system-log-daemon, klogd, syslogd
-Replaces: sysklogd, klogd, inetutils-syslogd
-Conflicts: klogd, syslogd, sysklogd, linux-kernel-log-daemon, system-log-daemon
+Provides: linux-kernel-log-daemon, system-log-daemon
+Conflicts: linux-kernel-log-daemon, system-log-daemon
 Description: Provides syslogd and klogd using busybox
  The system log daemon is responsible for providing logging of
  messages received from programs and facilities on the local host as
@@ -119,7 +124,7 @@
 Architecture: linux-any
 Depends: busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}), ${misc:Depends}
 Description: Provides the busybox DHCP client implementation
- Busybox contains a very small yet fully function RFC compliant DHCP
+ Busybox contains a very small yet fully functional RFC compliant DHCP
  client formerly known as udhcpc.
  .
  This package contains the glue to use the busybox udhcpc as DHCP

=== debian/rules ===
#!/usr/bin/make -f

SHELL := sh -e
DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
PKGVERSION := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')
VENDOR := $(shell dpkg-vendor --query vendor)

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
RUN_TESTSUITE = y
endif
TESTSUITE_ENV = SKIP_KNOWN_BUGS=y VERBOSE=y
# always run tests in UTF8 mode to verify unicode support
TESTSUITE_ENV += LANG=C.UTF8
#TESTSUITE_ENV += SKIP_INTERNET_TESTS=y

# support parallel build using DEB_BUILD_OPTIONS=parallel=N
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += \
    -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# build directory
b = build

# which flavours to build
flavours = deb static udeb initramfs

ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
export CROSS_COMPILE = ${DEB_HOST_GNU_TYPE}-
endif

# we filter out -Werror=format-security from CFLAGS, because
# bb uses constructs like
#  bb_error_msg_and_die(bb_msg_memory_exhausted);
# in many places, and for these, gcc with -Werror=format-security
# will complain, since bb_msg_memory_exhausted is an extern.
EXTRA_CFLAGS = \
 $(filter-out -Werror=format-security, $(shell dpkg-buildflags --get CFLAGS))
EXTRA_LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
EXTRA_CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

${b}/test754813.stamp:
	mkdir -p ${b}
	@echo "Checking if libc can produce working static binaries"
	echo 'int main(void) { return getpwnam("root") ? 0 : 1; }' > ${b}/test754813.c
	${CC} -static -o ${b}/test754813 ${b}/test754813.c
	@${b}/test754813 || { \
	  echo "E: your libc does not produce working statically linked binaries" >&2 ; \
	  echo "E: glibc-2.19 is known to have this bug: http://bugs.debian.org/754813" >&2 ; \
	  echo "E: and https://sourceware.org/bugzilla/show_bug.cgi?id=17250" >&2 ; \
	  echo "E: please update your libc" >&2 ; \
	  exit 1 ; }
	touch $@

build: build-arch build-indep
build-indep:

${b}/%/.stamp-setup: DIR = ${b}/$*
${b}/%/.stamp-setup: debian/config/pkg/% debian/config/os/${DEB_HOST_ARCH_OS} ${b}/test754813.stamp
	dh_testdir
	rm -rf ${DIR}
	mkdir -p ${DIR}
	cp -a -l $(filter-out debian ${b}, $(wildcard *)) ${DIR}

# Generate the .config file. First variable assignment wins.
# Several steps..

# 1, rm it just in case
	rm -f ${DIR}/.config

# 2, put any arch-specific overrides so they will have higher precedence
# should be empty for linux
	cat debian/config/os/${DEB_HOST_ARCH_OS} > ${DIR}/.config

# 3, on non-linux platform, disable all config symbols
# which select PLATFORM_LINUX.
# Configuration information is stored in source files and in Config.src,
# so we have to generate Config.in files first, -- done by gen_build_files.
	${MAKE} -C ${DIR} gen_build_files
ifneq (linux,${DEB_HOST_ARCH_OS})
	find ${DIR} -name Config.in -exec \
	  awk '$$1 == "config" { conf = $$2 } \
	       $$1 == "select" && $$2 == "PLATFORM_LINUX" \
	       { print "CONFIG_" conf "=n"; }' \
	   {} + \
        | sort -u >> ${DIR}/.config
endif

# 4, use the flavour-specific base config file.
	cat debian/config/pkg/$* >> ${DIR}/.config

# 5, sort out the resulting mess using oldconfig Kbuild machinery
	${MAKE} -C ${DIR} oldconfig

	ln -s .config $@

ifeq (y,${RUN_TESTSUITE})
# we run testsuite only for main flavour
test-dep := ${b}/deb/.stamp-test
else
test-dep :=
endif

build-arch: ${b}/stamp-build
${b}/stamp-build: $(patsubst %,${b}/%/.stamp-build, ${flavours}) ${test-dep}
	touch $@

${b}/%/.stamp-build: DIR = ${b}/$*
${b}/%/.stamp-build: ${b}/%/.stamp-setup
	dh_testdir
	$(MAKE) -C ${DIR} install docs/busybox.1 \
	  SKIP_STRIP=y \
	  BB_EXTRA_VERSION="${VENDOR} ${PKGVERSION}" \
	  CONFIG_EXTRA_CFLAGS='${EXTRA_CFLAGS} ${EXTRA_CPPFLAGS}' \
	  CONFIG_EXTRA_LDFLAGS='${EXTRA_LDFLAGS}'
	ln -sf busybox $@

test: ${b}/stamp-test
${b}/stamp-test: $(patsubst %,${b}/%/.stamp-test, ${flavours})
	touch $@
${b}/%/.stamp-test: DIR = ${b}/$*
${b}/%/.stamp-test: ${b}/%/.stamp-build
	@echo ======== running testsuite in ${DIR} ========
# mdev testsuite requires chroot which does not work as non-root user
	rm -f ${DIR}/testsuite/mdev.tests
# disable or fix some failing tests
	if [ -f debian/testsuite-${DEB_HOST_ARCH_OS}.diff ] && \
	   ! [ -f ${DIR}/.tests-fixed ]; then \
		( cd ${DIR} && patch -p1 && touch .tests-fixed; ) \
		  < debian/testsuite-${DEB_HOST_ARCH_OS}.diff ; \
	fi
	cd ${DIR}/testsuite && ${TESTSUITE_ENV} ./runtest -v
	touch $@

clean:
	dh_testdir
	rm -rf ${b}
	dh_clean

# define $a variable to be one of -i (indep), -a (arch) or nothing (both)
a :=
binary-indep: a := -i
binary-indep: install
binary-arch: a := -a
binary-arch: install
binary: install

install: ${b}/stamp-build
	dh_testroot
	dh_testdir
	dh_prep

	dh_installdocs $a
	dh_installchangelogs $a
	dh_install $a

# busybox
	dh_install -pbusybox ${b}/deb/busybox /bin
	dh_installman -pbusybox ${b}/deb/docs/busybox.1
	dh_installdocs -pbusybox docs/syslog.conf.txt docs/mdev.txt

# busybox-static
	dh_install -pbusybox-static ${b}/static/busybox /bin
	dh_installman -pbusybox-static ${b}/static/docs/busybox.1
	dh_installdocs -pbusybox-static docs/syslog.conf.txt docs/mdev.txt
	dh_installexamples -pbusybox-static examples/mdev* examples/udhcp

# busybox-udeb
	# Remove init link, but init support is still compiled in to be used.
	rm -f ${b}/udeb/_install/sbin/init
	dh_install -pbusybox-udeb ${b}/udeb/_install/* /

# busybox-syslogd
	dh_installinit -pbusybox-syslogd 
	dh_installinit -pbusybox-syslogd --name=busybox-klogd

# busybox-initramfs
	dh_install -pbusybox-initramfs ${b}/initramfs/busybox /usr/lib/initramfs-tools/bin/
	install -D debian/tree/busybox/usr/share/initramfs-tools/hooks/zz-busybox debian/busybox-initramfs/usr/share/initramfs-tools/hooks/zz-busybox-initramfs


ifeq (linux,$(DEB_HOST_ARCH_OS))
# udhcpc
# udhcpd
	dh_installinit -pudhcpd --onlyscripts
endif

# common actions

	dh_strip $a
	dh_link $a
	dh_compress $a
	dh_fixperms $a
	dh_installdeb $a
	dh_shlibdeps $a

# after shlibdeps finished, grab ${shlibs:Depends} from busybox package
# and transform it into Built-Using field (also dpkg-query bug #588505)
	if [ -f debian/busybox.substvars ]; then \
	  pkgs=$$(sed -n -e's/([^)]*)//g' -e's/,//g' -e's/^shlibs:Depends=//p' debian/busybox.substvars); \
	  srcs=; for p in $$pkgs; do \
	    srcs="$$srcs $$(dpkg-query -f '$${source:Package} (= $${source:Version}),' -W $$p)"; \
	  done ; \
	  echo "built-using=$$srcs" >> debian/busybox-static.substvars ; \
	fi

	dh_gencontrol $a
	dh_md5sums $a
	dh_builddeb $a

.PHONY: binary binary-arch binary-indep \
	build build-arch build-indep \
	clean setup install

.PRECIOUS: ${b}/%/.stamp-setup ${b}/%/.stamp-build ${b}/%/.stamp-test \
	${b}/stamp-%

=== debian/watch ===
version=3
http://busybox.net/downloads/busybox-([\d\.]*)\.tar\.bz2
